/* $Id$ */
#include "common.h"
#include "psdev.h"
/* 
 * ܡ/ޥߥ١
 * 褽 100 ޥðˡޤʤƤϤʤ
 * Keyboard Υǡμեޥå
 *    H01234567PL (P: Parity Even)
 *      ǡϡCLK 
 * Keyboard ؤΥǡХեޥå
 *    L01234567PH  (P: Parity Even)
 *      ǡФϡCLK 
 */
/*
ܡɤϡL01234567PH (P=ѥƥ)ηǥǡäƤ롣
Ÿľϡޤ "AA : RESET_DONE" äƤ롣

θ
	 -> 󥳡
	Υ -> "F0" 󥳡
äƤ褦

 ޥĤʤ硢AA : RESET_DONE ʤ
CMD_SET_SAMPLING_RATE ȯԤʤȻȤʤ褦


*/


/*
 * kbd_init ---  ߤ褦ˤ
 * kbd_intr --- ߽
 * kbd_inh  --- ҥӥå	(Ȥʤͽ)
 * kbd_eni  --- ҥӥåȲ (Ȥʤͽ)
 *
 */
extern int ierror;

kbd_init() {
	buffer_init(&kbd_recv_data);
	orb(ISCR, (1<<KBD_IRQ)); // faling-edge sensing
	orb(IER, (1<<KBD_IRQ)); // enable irq
}

kbd_inh() {
	outb(IER, inb(IER) & ~(1<<KBD_IRQ)); // disable irq
	kbd_ddr |= (1<<KBD_CLK_BIT);
	outb(KBD_DDR, kbd_ddr); // send CLK "L"
}

kbd_eni() {
	kbd_ddr &= ~(1<<KBD_CLK_BIT);		// send CLK "H"
	outb(KBD_DDR, kbd_ddr);
	outb(IER, inb(IER) | (1<<KBD_IRQ));  // enable irq
}

volatile int kbd_recv_cnt;
volatile int kbd_recving;
volatile long last_kbd_modified;

volatile struct buffer kbd_recv_data;

volatile int kbd_sending;
volatile int kbd_send_cnt;

volatile int kbd_recv_diff;
volatile int kbd_intr_cnt;

volatile int kbd_ov_cnt;
volatile int kbd_to_cnt;

#pragma interrupt
kbd_intr() {
	kbd_intr_cnt++;
	if (kbd_send_cnt) {
		kbd_send_cnt--;
		if (kbd_sending & 1) {
			kbd_ddr &= ~(1<<KBD_DATA_BIT);
		} else {
			kbd_ddr |= (1<<KBD_DATA_BIT);
		}
		outb(KBD_DDR,kbd_ddr);
		kbd_sending >>= 1;
		if (kbd_send_cnt == 0) {
			if (inb(KBD_PORT) & (1<<KBD_DATA_BIT)) {
				// ϥ顼
			}
		}
	} else {
		if ((systicks - last_kbd_modified ) > 1 ) {
			// 1m  ʾ֤ǡϡΤƤ롣
			kbd_to_cnt += kbd_recv_cnt;
			kbd_recv_diff = systicks - last_kbd_modified;
			kbd_recv_cnt = kbd_recving = 0;
		} else {
			kbd_recving >>= 1;
		}
		kbd_recv_cnt++;
		if (inb(KBD_PORT) & (1<<KBD_DATA_BIT)) {
			kbd_recving |= (1<<10);
		}
		if (kbd_recv_cnt == 11) {
			if (buffer_put(&kbd_recv_data,kbd_recving>>1) < 0) {
				kbd_ov_cnt++;
			}
			kbd_recv_cnt = kbd_recving = 0;
		}
		last_kbd_modified = systicks;
	}
}


kbd_send(n) {
	int i;
	long cur_time;
	int s;

	for (i=0; i<20; i++) {
		while ((systicks - last_kbd_modified ) <= 1 ) {
			;
		}
		s = inh();
		if (kbd_recv_cnt) {
			eni(s);
			continue;
		} else {
			kbd_sending = (n&0xff) |(parity(n)?0:0x100)|0x200|0x400;
			kbd_send_cnt = 11;
			kbd_ddr |= (1<<KBD_DATA_BIT);
			outb(KBD_DDR,kbd_ddr);
			break;
		}
	}
	eni(s);
	cur_time = systicks;
	while (kbd_send_cnt > 0) {
		if (systicks - cur_time > 1) { // timeout
			if (kbd_send_cnt == 11) {
				ierror |= 32;
			} else if (kbd_send_cnt == 1) {
				ierror |= 64;
			} else {
				ierror |= 128;
			}
			kbd_send_cnt = 0;
			return 1;
		}
	}
	return 0;
}

kbd_flush() {
	int i,s;

	for (i=0; i<20; i++) {
		if (kbd_recv_cnt == 0) {
			break;
		}
		delay(300);
	}
	s = inh();
	buffer_init(&kbd_recv_data);
	kbd_recv_cnt = kbd_recving = 0;
	eni(s);
}
