/* $Id$ */
#include "common.h"
#include "psdev.h"
/* 
 * ܡ/ޥߥ١
 * 褽 100 ޥðˡޤʤƤϤʤ
 * Keyboard Υǡμեޥå
 *    H01234567PL (P: Parity Even)
 *      ǡϡCLK 
 * Keyboard ؤΥǡХեޥå
 *    L01234567PH  (P: Parity Even)
 *      ǡФϡCLK 
 */
/*
ܡɤϡL01234567PH (P=ѥƥ)ηǥǡäƤ롣
Ÿľϡޤ "AA : RESET_DONE" äƤ롣

θ
	 -> 󥳡
	Υ -> "F0" 󥳡
äƤ褦

 ޥĤʤ硢AA : RESET_DONE ʤ
CMD_SET_SAMPLING_RATE ȯԤʤȻȤʤ褦


*/


/*
 * psm_init ---  ߤ褦ˤ
 * psm_intr --- ߽
 * psm_inh  --- ҥӥå	(Ȥʤͽ)
 * psm_eni  --- ҥӥåȲ (Ȥʤͽ)
 *
 */
extern int ierror;

psm_init() {
	buffer_init(&psm_recv_data);
	orb(ISCR, (1<<PSM_IRQ)); // faling-edge sensing
	orb(IER, (1<<PSM_IRQ)); // enable irq
}

psm_inh() {
	outb(IER, inb(IER) & ~(1<<PSM_IRQ)); // disable irq
	psm_ddr |= (1<<PSM_CLK_BIT);
	outb(PSM_DDR, psm_ddr); // send CLK "L"
}

psm_eni() {
	psm_ddr &= ~(1<<PSM_CLK_BIT);		// send CLK "H"
	outb(PSM_DDR, psm_ddr);
	outb(IER, inb(IER) | (1<<PSM_IRQ));  // enable irq
}

volatile int psm_recv_cnt;
volatile int psm_recving;
volatile long last_psm_modified;

volatile struct buffer psm_recv_data;

volatile int psm_sending;
volatile int psm_send_cnt;

volatile int psm_recv_diff;
volatile int psm_intr_cnt;

volatile int psm_ov_cnt;
volatile int psm_to_cnt;

#pragma interrupt
psm_intr() {
	psm_intr_cnt++;
	if (psm_send_cnt) {
		psm_send_cnt--;
		if (psm_sending & 1) {
			psm_ddr &= ~(1<<PSM_DATA_BIT);
		} else {
			psm_ddr |= (1<<PSM_DATA_BIT);
		}
		outb(PSM_DDR,psm_ddr);
		psm_sending >>= 1;
		if (psm_send_cnt == 0) {
			if (inb(PSM_PORT) & (1<<PSM_DATA_BIT)) {
				// ϥ顼
			}
		}
	} else {
		if ((systicks - last_psm_modified ) > 1 ) {
			// 1m  ʾ֤ǡϡΤƤ롣
			psm_to_cnt += psm_recv_cnt;
			psm_recv_diff = systicks - last_psm_modified;
			psm_recv_cnt = psm_recving = 0;
		} else {
			psm_recving >>= 1;
		}
		psm_recv_cnt++;
		if (inb(PSM_PORT) & (1<<PSM_DATA_BIT)) {
			psm_recving |= (1<<10);
		}
		if (psm_recv_cnt == 11) {
			if (buffer_put(&psm_recv_data,psm_recving>>1) < 0) {
				psm_ov_cnt++;
			}
			psm_recv_cnt = psm_recving = 0;
		}
		last_psm_modified = systicks;
	}
}


psm_send(n) {
	int i;
	long cur_time;
	int s;

	for (i=0; i<20; i++) {
		while ((systicks - last_psm_modified ) <= 1 ) {
			;
		}
		s = inh();
		if (psm_recv_cnt) {
			eni(s);
			continue;
		} else {
			psm_sending = (n&0xff) |(parity(n)?0:0x100)|0x200|0x400;
			psm_send_cnt = 11;
			psm_ddr |= (1<<PSM_DATA_BIT);
			outb(PSM_DDR,psm_ddr);
			break;
		}
	}
	eni(s);
	cur_time = systicks;
	while (psm_send_cnt > 0) {
		if (systicks - cur_time > 1) { // timeout
			if (psm_send_cnt == 11) {
				ierror |= 32;
			} else if (psm_send_cnt == 1) {
				ierror |= 64;
			} else {
				ierror |= 128;
			}
			psm_send_cnt = 0;
			return 1;
		}
	}
	return 0;
}

psm_flush() {
	int i,s;

	for (i=0; i<20; i++) {
		if (psm_recv_cnt == 0) {
			break;
		}
		delay(300);
	}
	s = inh();
	buffer_init(&psm_recv_data);
	psm_recv_cnt = psm_recving = 0;
	eni(s);
}
